=== debian/changelog ===
faust (2.54.9+ds0-1) unstable; urgency=medium

  * New upstream version 2.54.9+ds0
    + Refresh patches
  * Install 'faust2cmajor' transpiler, remove dropped 'faust2soul'
  * Make help2man dependency optional (when cross-building)
  * Use execute_before_dh_* instead of override_dh_*
  * Use d/clean instead of overriding dh_clean
  * Update d/copyright
    + Modernize 'licensecheck' target
    + Re-generate d/copyright_hints
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 04 Jan 2023 10:18:27 +0100

faust (2.50.6+ds0-1) unstable; urgency=medium

  * New upstream version 2.50.6+ds0
    + Refresh patches
    + Remove patches applied upstream
  * Add patch to avoid bashisms
  * Update d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 07 Oct 2022 22:15:56 +0200

faust (2.41.1~ds0-2) unstable; urgency=medium

  * Add patch to prevent static linking against libsndfile (Closes: #1020000)
  * Switch d/watch to use github-API for monitoring releases

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Sep 2022 10:46:33 +0200
