=== debian/watch ===
# github broke the releases page, so we now have to use the API...
version=4
opts="searchmode=plain, \
  repacksuffix=+ds0, \
  dversionmangle=auto" \
	https://api.github.com/repos/grame-cncm/faust/releases \
	https://github.com/grame-cncm/faust/releases/download/\d[\.\d]*/faust-@ANY_VERSION@.tar.gz
